## pgloader-bundle-3.4.1.tgz

=== Makefile ===
# pgloader build tool for bundle tarball
# only supports SBCL
CL = sbcl

APP_NAME   = pgloader
VERSION    = 3.4.1

ifeq ($(OS),Windows_NT)
EXE           = .exe
COMPRESS_CORE = no
DYNSIZE       = 1024		# support for windows 32 bits
else
DYNSIZE       = 4096
EXE =
endif

BUILDDIR   = bin
BUILDAPP   = $(BUILDDIR)/buildapp$(EXE)
PGLOADER   = ./bin/pgloader

SRCDIR = local-projects/pgloader-$(VERSION)

BUILDAPP_OPTS = --require sb-posix                      \
                --require sb-bsd-sockets                \
                --require sb-rotate-byte
CL_OPTS    = --noinform --no-sysinit --no-userinit

COMPRESS_CORE ?= $(shell $(CL) --noinform \
                               --quit     \
                               --eval '(when (member :sb-core-compression cl:*features*) (write-string "yes"))')

ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
endif

pgloader: $(PGLOADER) ;
buildapp: $(BUILDAPP) ;

$(BUILDAPP):
	mkdir -p $(BUILDDIR)
	$(CL) $(CL_OPTS) --load bundle.lisp                           \
             --eval '(asdf:load-system :buildapp)'                    \
             --eval '(buildapp:build-buildapp "$@")'                  \
             --eval '(quit)'

$(PGLOADER): $(BUILDAPP)
	$(BUILDAPP)      --logfile /tmp/pgloader-bundle-build.log     \
                         $(BUILDAPP_OPTS)                             \
                         --sbcl $(CL)                                 \
                         --asdf-tree .                                \
                         --load-system $(APP_NAME)                    \
                         --eval '(setf pgloader.params::*version-string* "$(VERSION)")' \
                         --load $(SRCDIR)/src/hooks.lisp              \
                         --entry pgloader:main                        \
                         --dynamic-space-size $(DYNSIZE)              \
                         $(COMPRESS_CORE_OPT)                         \
                         --output $@.tmp
	# that's ugly, but necessary when building on Windows :(
	mv $@.tmp $@

test: $(PGLOADER)
	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) -C $(SRCDIR)/test regress

check: test ;

=== local-projects/pgloader-3.4.1/Makefile ===
# pgloader build tool
APP_NAME   = pgloader
VERSION    = 3.3.2

# use either sbcl or ccl
CL	   = sbcl

# default to 4096 MB of RAM size in the image
DYNSIZE    = 4096

LISP_SRC   = $(wildcard src/*lisp)         \
             $(wildcard src/monkey/*lisp)  \
             $(wildcard src/utils/*lisp)   \
             $(wildcard src/parsers/*lisp) \
             $(wildcard src/pgsql/*lisp)   \
             $(wildcard src/sources/*lisp) \
             pgloader.asd

BUILDDIR   = build
LIBS       = $(BUILDDIR)/libs.stamp
QLDIR      = $(BUILDDIR)/quicklisp
MANIFEST   = $(BUILDDIR)/manifest.ql
LATEST     = $(BUILDDIR)/pgloader-latest.tgz
BUNDLENAME = pgloader-bundle-$(VERSION)
BUNDLEDIR  = $(BUILDDIR)/bundle/$(BUNDLENAME)
BUNDLE     = $(BUILDDIR)/$(BUNDLENAME).tgz

ifeq ($(OS),Windows_NT)
EXE           = .exe
COMPRESS_CORE = no
DYNSIZE       = 1024		# support for windows 32 bits
else
EXE =
endif

PGLOADER   = $(BUILDDIR)/bin/$(APP_NAME)$(EXE)
BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl$(EXE)
BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl$(EXE)

ifeq ($(CL),sbcl)
BUILDAPP      = $(BUILDAPP_SBCL)
BUILDAPP_OPTS = --require sb-posix                      \
                --require sb-bsd-sockets                \
                --require sb-rotate-byte
CL_OPTS    = --noinform --no-sysinit --no-userinit
else
BUILDAPP   = $(BUILDAPP_CCL)
CL_OPTS    = --no-init
endif

ifeq ($(CL),sbcl)
COMPRESS_CORE ?= $(shell $(CL) --noinform \
                               --quit     \
                               --eval '(when (member :sb-core-compression cl:*features*) (write-string "yes"))')

endif

# note: on Windows_NT, we never core-compress; see above.
ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
endif

DEBUILD_ROOT = /tmp/pgloader

all: $(PGLOADER)

clean:
	rm -rf $(LIBS) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGLOADER)

docs:
	ronn -roff pgloader.1.md

$(QLDIR)/local-projects/qmynd:
	git clone --depth 1 https://github.com/qitab/qmynd.git $@

$(QLDIR)/local-projects/cl-ixf:
	git clone --depth 1 https://github.com/dimitri/cl-ixf.git $@

$(QLDIR)/local-projects/cl-db3:
	git clone --depth 1 https://github.com/dimitri/cl-db3.git $@

$(QLDIR)/local-projects/cl-csv:
	git clone --depth 1 https://github.com/AccelerationNet/cl-csv.git $@

$(QLDIR)/setup.lisp:
	mkdir -p $(BUILDDIR)
	curl -o $(BUILDDIR)/quicklisp.lisp http://beta.quicklisp.org/quicklisp.lisp
	$(CL) $(CL_OPTS) --load $(BUILDDIR)/quicklisp.lisp                        \
             --load src/getenv.lisp                                               \
             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp" :proxy (getenv "http_proxy"))' \
             --eval '(quit)'

quicklisp: $(QLDIR)/setup.lisp ;

clones: $(QLDIR)/local-projects/cl-ixf \
        $(QLDIR)/local-projects/cl-db3 \
        $(QLDIR)/local-projects/cl-csv \
        $(QLDIR)/local-projects/qmynd ;

$(LIBS): $(QLDIR)/setup.lisp clones
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
             --eval '(push "$(PWD)/" asdf:*central-registry*)'      \
             --eval '(ql:quickload "pgloader")'                     \
             --eval '(quit)'
	touch $@

libs: $(LIBS) ;

$(MANIFEST): $(LIBS)
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:write-asdf-manifest-file "$(MANIFEST)")'  \
             --eval '(quit)'

manifest: $(MANIFEST) ;

$(BUILDAPP_CCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

$(BUILDAPP_SBCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

buildapp: $(BUILDAPP) ;

$(PGLOADER): $(MANIFEST) $(BUILDAPP) $(LISP_SRC)
	mkdir -p $(BUILDDIR)/bin
	$(BUILDAPP)      --logfile /tmp/build.log                \
                         $(BUILDAPP_OPTS)                        \
                         --sbcl $(CL)                            \
                         --asdf-path .                           \
                         --asdf-tree $(QLDIR)/local-projects     \
                         --manifest-file $(MANIFEST)             \
                         --asdf-tree $(QLDIR)/dists              \
                         --asdf-path .                           \
                         --load-system $(APP_NAME)               \
                         --load src/hooks.lisp                   \
                         --entry pgloader:main                   \
                         --dynamic-space-size $(DYNSIZE)         \
                         $(COMPRESS_CORE_OPT)                    \
                         --output $@.tmp
	# that's ugly, but necessary when building on Windows :(
	mv $@.tmp $@

pgloader: $(PGLOADER) ;

pgloader-standalone:
	$(BUILDAPP)    $(BUILDAPP_OPTS)                        \
                       --sbcl $(CL)                            \
                       --load-system $(APP_NAME)               \
                       --load src/hooks.lisp                   \
                       --entry pgloader:main                   \
                       --dynamic-space-size $(DYNSIZE)         \
                       $(COMPRESS_CORE_OPT)                    \
                       --output $(PGLOADER)
test: $(PGLOADER)
	$(MAKE) PGLOADER=$(realpath $(PGLOADER)) CL=$(CL) -C test regress

clean-bundle:
	rm -rf $(BUNDLEDIR)

$(BUNDLEDIR):
	mkdir -p $@
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:bundle-systems (list "pgloader" "buildapp") :to "$@")' \
             --eval '(quit)'

$(BUNDLE): $(BUNDLEDIR)
	cp bundle/README.md $(BUNDLEDIR)
	sed -e s/%VERSION%/$(VERSION)/ < bundle/Makefile > $(BUNDLEDIR)/Makefile
	git archive --format=tar --prefix=pgloader-$(VERSION)/ master \
	     | tar -C $(BUNDLEDIR)/local-projects/ -xf -
	make QLDIR=$(BUNDLEDIR) clones
	tar -C build/bundle 		    \
            --exclude bin   		    \
            --exclude test/sqlite           \
            -czf $@ pgloader-bundle-$(VERSION)

bundle: $(BUNDLE)

test-bundle:
	$(MAKE) -C $(BUNDLEDIR) test


deb:
	# intended for use on a debian system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	rsync -Ca --exclude 'build'                      		  \
		  --exclude '.vagrant'                   		  \
		  --exclude 'test/sqlite-chinook.load'   		  \
		  --exclude 'test/sqlite'                		  \
		  --exclude 'test/data/2013_Gaz_113CDs_national.txt'      \
		  --exclude 'test/data/reg2013.dbf'      		  \
		  --exclude 'test/data/sakila-db.zip'    		  \
              ./ $(DEBUILD_ROOT)/
	cd $(DEBUILD_ROOT) && make -f debian/rules orig
	cd $(DEBUILD_ROOT) && debuild -us -uc -sa
	cp -a /tmp/pgloader_* /tmp/cl-pgloader* build/

rpm:
	# intended for use on a CentOS or other RPM based system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)
	rsync -Ca --exclude=build/* ./ $(DEBUILD_ROOT)/
	cd /tmp && tar czf $(HOME)/rpmbuild/SOURCES/pgloader-$(VERSION).tar.gz pgloader
	cd $(DEBUILD_ROOT) && rpmbuild -ba pgloader.spec
	cp -a $(HOME)/rpmbuild/SRPMS/*rpm build
	cp -a $(HOME)/rpmbuild/RPMS/x86_64/*rpm build

pkg:
	# intended for use on a MacOSX system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)/*
	mkdir -p $(DEBUILD_ROOT)/usr/local/bin/
	mkdir -p $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./pgloader.1 $(DEBUILD_ROOT)/usr/local/share/man/man1/
	cp ./build/bin/pgloader $(DEBUILD_ROOT)/usr/local/bin/
	pkgbuild --identifier org.tapoueh.pgloader \
	         --root $(DEBUILD_ROOT)            \
	         --version $(VERSION)              \
                 ./build/pgloader-$(VERSION).pkg

latest:
	git archive --format=tar --prefix=pgloader-$(VERSION)/ v$(VERSION) \
        | gzip -9 > $(LATEST)

check: test ;

.PHONY: test pgloader-standalone docs

=== software/pgloader-3.3.2/debian/changelog ===
pgloader (3.3.2+dfsg-1) unstable; urgency=medium

  * Fixes github issue 453 (Closes: #843555)
  * Maintenance release.

 -- Dimitri Fontaine <dim@tapoueh.org>  Sat, 03 Dec 2016 19:36:56 +0300

pgloader (3.3.1+dfsg-2) unstable; urgency=medium

  * Add tzdata to build-depends (Closes: #839468)

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 03 Nov 2016 14:32:28 +0100

pgloader (3.3.1+dfsg-1) unstable; urgency=medium

  * New release, bugfixes and new features

 -- Dimitri Fontaine <dim@tapoueh.org>  Sun, 28 Aug 2016 21:07:47 +0300

pgloader (3.2.2+dfsg-1) unstable; urgency=medium

  * New release, lots of bugfixes, some new features
  * New build dependencies

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 03 Sep 2015 19:17:12 +0300

pgloader (3.2.1~preview+dfsg-2) unstable; urgency=medium

  * Interim bugfix release

 --  Dimitri Fontaine <dim@tapoueh.org>  Thu, 22 Jan 2015 04:06:51 +0400

pgloader (3.2.0+dfsg-1) unstable; urgency=medium

  * Implement COPY files support
  * Implement MS SQL source database support
  * Lots of bug fixes
  * Full command line operations support
  * Misc improvements, cleanup, refactoring

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 15 Jan 2015 19:51:02 +0300

pgloader (3.1.1+dfsg-1) unstable; urgency=medium

  * Fix --root-dir option when target directory doesn't exists (Closes:#767288)
  * New release, lots of bugfixes
  * Add support for CAST rules for SQLite
  * Code refactoring
  * New file based sources filters and options
  
 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 03 Nov 2014 16:08:19 +0300

pgloader (3.1.0+dfsg-3) unstable; urgency=medium

  * Fix build dependencies problems, see Bug#765162

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 28 Oct 2014 12:41:23 +0300

pgloader (3.1.0+dfsg-2) unstable; urgency=medium

  * Fix building on i386 machines, using 1GB of dynamic space there.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 22 Sep 2014 23:04:18 +0400

pgloader (3.1.0+dfsg-1) unstable; urgency=medium

  * Stable release of the new pgloader version, 3.1

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 10 Sep 2014 16:48:11 +0400

pgloader (3.0.99-1) unstable; urgency=medium

  * Release Candidate 9
  * Can be built against either CCL or SBCL
  * Lots of bug fixes
  * Smarted batch memory usage

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 29 Apr 2014 13:50:26 +0400

pgloader (3.0.98-1) unstable; urgency=low

  * Release Candidate 8
  * Fixes retry behavior
  * Assorted fixes

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 23 Jan 2014 03:19:07 +0400

pgloader (3.0.97-1) unstable; urgency=low

  * Release Candidate 7
  * Fix log-filename location
  * Switch to the new cl-csv version
  * Add a documentation website with tutorials
  * Fix ASDF dependencies

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 15 Jan 2014 01:33:16 +0400

pgloader (3.0.96-1) unstable; urgency=low

  * Release Candidate 6
  * Document then rework the batch retry behavior.
  * Various bug fixes, including CCL compatibility.
  
 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 27 Dec 2013 15:11:02 +0400

pgloader (3.0.95-1) unstable; urgency=low

  * Release Candidate 5.
  * Minimize memory usage, bug fixes.

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 18 Dec 2013 23:32:33 +0100

pgloader (3.0.94-1) unstable; urgency=low

  * Release Candidate 4.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 09 Dec 2013 14:58:51 +0400

pgloader (2.3.3~dev3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't hardcode dependency on python-support, use ${python:Depends}
    (closes: #542052). Thanks to Faheem Mitha for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 06 Jan 2012 02:19:25 +0100

pgloader (2.3.3~dev3-1) unstable; urgency=low

  * Implement -f --field-sep to overwrite the default from command line
  * Add support for filename arguments, which use defaults
  * Implement --reject-log and --reject-data
  * Add support for --max-parallel-sections and --section-threads
  * Support setting any PG option (-o and config file)
  * Have --debug show a traceback
  * Fix a bug where pgloader would freeze on early error (no such file)
  * Implement an option to set csv field size limit
  * Implement --load-from-stdin
  * Implement --boundaries
  * use gettempdir() rather than hard-coded "/tmp"
  * Handle C-c the default system's way
  * Fix pgloader thread error management
  * Fix exit status to be non-zero in case of known errors

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 09 Nov 2010 16:10:01 +0100

pgloader (2.3.2-1) unstable; urgency=low

  * Implement --from support in all readers (Closes: #531034)
  * Use psycopg cursor.copy_expert() when available (> 2.0.6)
  * FIX fixedreader: it now know about -C
  * FIX Round Robin Reader with respect to offsets in readlines()
  * support python 2.3 if not using RRR (not importing collections.deque)
  * change logger initialisation to support python 2.3
  * FIX bad usage of STDERR in the code
  * Implement skip_head_lines option in configuration (superseded by -F)
  * Do not sort() section list when it's been given on command line
  * Catch InterfaceError when trying to close connection

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 29 Jun 2009 09:39:33 +0200

pgloader (2.3.1-2) unstable; urgency=low

  * FIX Missing Build-Depends (Closes: #485067)

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 09 Jun 2008 15:23:56 +0200

pgloader (2.3.1-1) unstable; urgency=low

  * FIX: Add database opening into critical path (BoundedSemaphore)
  * FIX: close database connection as soon as possible
  * Add support for fixed format
  * Add support for escaped field_sep, such as \t

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 21 May 2008 12:19:42 +0200

pgloader (2.3.0-1) unstable; urgency=low

  * FIX the cluttered test case, see BUGS.txt
  * Better release it as stable now and fix bugs when found than wait for
    more testing of the ~dev release candidates.

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 10 Mar 2008 15:36:04 +0100



=== software/pgloader-3.3.2/debian/control ===
Source: pgloader
Section: database
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders: Christoph Berg <myon@debian.org>
Build-Depends: debhelper (>= 8.0.0), sbcl (>= 1.1.13), ruby-ronn, buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-ixf, gawk, cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-mssql, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre, tzdata
Standards-Version: 3.9.6
Homepage: https://github.com/dimitri/pgloader
Vcs-Git: https://github.com/dimitri/pgloader.git
Vcs-Browser: https://github.com/dimitri/pgloader

Package: pgloader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freetds-dev
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.

Package: cl-pgloader
Architecture: all
Depends: ${misc:Depends}, cl-asdf (>= 3.0.3), cl-log, cl-postmodern, cl-simple-date, cl-qmynd, cl-split-sequence, cl-unicode, cl-interpol, cl-csv, cl-fad, cl-lparallel, cl-esrap, cl-alexandria, cl-drakma, cl-flexi-streams, cl-usocket, cl-local-time, cl-command-line-arguments, cl-abnf, cl-db3, cl-py-configparser, cl-sqlite, cl-trivial-backtrace, cl-markdown, cl-md5, cl-asdf-finalizers, cl-asdf-system-connections, cl-cffi (>= 1:0.12.0), cl-bordeaux-threads (>= 0.8.3), cl-metabang-bind, cl-uuid, cl-trivial-utf-8, cl-quri, cl-utilities, cl-ppcre
Description: extract, transform and load data into PostgreSQL
 pgloader imports data from different kind of sources and COPY it into
 PostgreSQL.
 .
 The command language is described in the manual page and allows one to
 describe where to find the data source, its format, and to describe data
 processing and transformation.
 .
 Supported source formats include CSV, fixed width flat files, dBase3 files
 (DBF), and SQLite and MySQL databases. In most of those formats, pgloader
 is able to auto-discover the schema and create the tables and the indexes
 in PostgreSQL. In the MySQL case it's possible to edit CASTing rules from
 the pgloader command directly.
